Subject: Re: [PATCH 4/4] Implement git commit and status as a builtin commands.

From: Pierre Habouzit <[email-masked]>
Date: Tue, 06 Nov 2007 10:26:48 +0100

On Tue, Nov 06, 2007 at 09:18:02AM +0000, Johannes Sixt wrote:
> Pierre Habouzit schrieb:
> >Btw, I'm starting to work slowly on the diff_opt_parse conversion to the
> >macro we discussed, and the need for new option parsing callbacks
> >arised, and I've created a:
> >  parse_opt_mask_{or,and,xor} commands that you declare this way:
> >    OPT_MASK_OR('a', "all",         &mode, "...", MASK_ALL),
> >    OPT_MASK_OR('i', "interactive", &mode, "...", MASK_INTERACTIVE),
> >    ...
> >And if you chose MASK_ALL/INTERACTIVE/.. to be single bits,
> >    if (!!all + !!interactive ... > 1)
> >becomes[0]:
> >    if (mode & (mode - 1)) {
> >    }
> 
> This goes too far, IMHO. That's unnecessary cleverness/microoptimization 
> at the expense of readability.

The reason why I did that is not to be able to do mode & (mode - 1).
Have a look at diff.c, imagine the insane amount of intermediate
variables we would need, and now understand why I introduced that :)

I'm not sure it's useful for git-commit, I was mentioning it just in case.

Note: the fact that an OPT_BOOLEAN when you repeat it increments the
      value isn't always a good thing, and is the reason why you need
      the (quite ugly) double bangs.

-- 
·O·  Pierre Habouzit
··O                                                [email-masked]
OOO                                                http://www.madism.org